-- Metadata hack to update and add tables
-- --------------------------------------

--
-- Add columns for title, meta description and keywords
-- for product
--
ALTER TABLE `jos_vm_product`
    ADD COLUMN `product_title` text,
    ADD COLUMN `product_metadesc` text,
    ADD COLUMN `product_metakey` text,
    ADD COLUMN `product_abstract` text,
    ADD COLUMN `product_canonical` text;


--
-- Add columns for title, meta description and keywords
-- for categories
--

ALTER TABLE `jos_vm_category` 
  ADD COLUMN `category_title` text,
  ADD COLUMN `category_metadesc` text,
  ADD COLUMN `category_metakey` text,
  ADD COLUMN `category_abstract` text,
  ADD COLUMN `category_canonical` text;


--
-- Add columns global metadata settings
-- for products
--
CREATE TABLE `jos_vm_product_metakeys` (
  `mid` int(11) NOT NULL auto_increment,
  `banned` text,
  `remove_less_than` int(11) NOT NULL DEFAULT '4',
  `number_of_keywords` int(11) NOT NULL DEFAULT '30',
  `append_category` char(1) NULL default 'N',
  `general_append_end` text,
  `general_append_end_title` text,
  `general_append_keys` text,
  `general_append_keys_phrase` text,
  `append_prod_name_phrase` char(1) NULL default 'N',
  `append_par_cat_name_phrase` char(1) NULL default 'N',
  `turn_on_edit` char(1) NULL default 'N',
  `add_abstract` char(1) NULL default 'N',
  `generator` text,
  `subject` char(1) NULL default 'N',
  `classification` text,
  `author` text,
  `organization` text,
  `copyright` text,
  `country` text,
  `content_language` text,
  `language` text,
  `designer` text,
  `comments` text,
  `no_email_collection` char(1) NULL default 'N',
  PRIMARY KEY  (`mid`)
) TYPE=MyISAM CHARACTER SET `utf8`;


--
-- Add columns for global metadata settings
-- for categories
--
CREATE TABLE `jos_vm_category_metakeys` (
  `mid` int(11) NOT NULL auto_increment,
  `banned` text,
  `remove_less_than` int(11) NOT NULL DEFAULT '4',
  `number_of_keywords` int(11) NOT NULL default '30',
  `append_category` char(1) NULL default 'N',
  `general_append_end` text,
  `general_append_end_title` text,
  `general_append_keys` text,
  `general_append_keys_phrase` text,
  `append_subcategory_title` char(1) NULL default 'N',
  `append_subcategory_description` char(1) NULL default 'N',
  `prepend_cat_name_phrase` char(1) NULL default 'N',
  `prepend_par_cat_name_phrase` char(1) NULL default 'N',
  `turn_on_edit` char(1) NULL default 'N',
  `add_abstract` char(1) NULL default 'N',
  `generator` text,
  `subject` char(1) NULL default 'N',
  `classification` text,
  `author` text,
  `organization` text,
  `copyright` text,
  `country` text,
  `content_language` text,
  `language` text,
  `designer` text,
  `comments` text,
  `no_email_collection` char(1) NULL default 'N',
  PRIMARY KEY  (`mid`)
) TYPE=MyISAM CHARACTER SET `utf8`;


--
-- Inset default global settings
-- for products
--
INSERT INTO `jos_vm_product_metakeys` VALUES ('1', 'a\, u\, about\, above\, across\, after\, afterwards\, again\, against\, all\, almost\, alone\, along\, already\, also\, although\, always\, am\, among\, amongst\, amoungst\, amount\, an\, and\, another\, any\, anyhow\, anyone\, anything\, anyway\, anywhere\, are\, around\, as\, at\, back\, be\, became\, because\, become\, becomes\, becoming\, been\, before\, beforehand\, behind\, being\, below\, beside\, besides\, between\, beyond\, bill\, both\, bottom\, bull\, but\, by\, call\, can\, cannot\, cant\, co\, computer\, con\, could\, couldnt\, cry\, de\, describe\, detail\, do\, done\, down\, due\, during\, each\, eg\, eight\, either\, eleven\, else\, elsewhere\, empty\, enough\, etc\, even\, ever\, every\, everyone\, everything\, everywhere\, except\, few\, feet\, fifteen\, fify\, fill\, finish\, find\, first\, five\, for\, former\, formerly\, forty\, found\, four\, from\, front\, ft\, full\, further\, get\, give\, go\, had\, has\, hasnt\, have\, he\, hence\, her\, here\, hereafter\, hereby\, herein\, hereupon\, hers\, herself\, him\, himself\, his\, how\, however\, hundred\, i\, ie\, if\, in\, inc\, inch\, inches\, include\, includes\, indeed\, interest\, into\, is\, it\, its\, itself\, keep\, last\, latter\, latterly\, least\, less\, like\, ltd\, made\, many\, may\, me\, meanwhile\, might\, mill\, mine\, minus\, more\, moreover\, most\, mostly\, move\, much\, must\, my\, myself\, name\, namely\, neither\, never\, nevertheless\, next\, nine\, no\, nobody\, none\, noone\, nor\, not\, nothing\, now\, nowhere\, of\, off\, often\, on\, once\, one\, only\, onto\, or\, other\, others\, otherwise\, our\, ours\, ourselves\, out\, over\, own\, part\, pd\, pds\, per\, perhaps\, place\, please\, plus\, pound\, pounds\, put\, provide\, provides\, question\, questions\, rather\, re\, ready\, rugged\, same\, see\, seem\, seemed\, seeming\, seems\, serious\, several\, she\, should\, show\, side\, since\, sincere\, six\, sixty\, so\, some\, somehow\, someone\, something\, sometime\, sometimes\, somewhere\, start\, still\, such\, system\, take\, ten\, than\, that\, the\, their\, them\, themselves\, then\, thence\, there\, thereafter\, thereby\, therefore\, therein\, thereupon\, these\, they\, thick\, thin\, third\, this\, those\, though\, three\, through\, throughout\, thru\, thus\, to\, today\, together\, too\, top\, total\, toward\, towards\, twelve\, twenty\, two\, un\, under\, unes\, until\, up\, upon\, us\, use\, uses\, used\, very\, via\, want\, wanted\, was\, we\, weight\, well\, were\, wgt\, what\, whatever\, when\, whence\, whenever\, where\, whereafter\, whereas\, whereby\, wherein\, whereupon\, wherever\, whether\, which\, while\, whither\, who\, whoever\, whole\, whom\, whose\, why\, will\, with\, within\, without\, would\, wt\, yet\, you\, your\, yours\, yourself\, yourselves', '4', '30', 'Y', '', '', 'product\, products\, buy\, top\, best\, value\, store\, shop\, new\, used', 'buy product\, purchase products', 'Y', 'Y', 'N', 'N', '', 'N', '', '', '', '', '', '', '', '', '', 'N');


--
-- Inset default global settings
-- for categories
--
INSERT INTO `jos_vm_category_metakeys` VALUES ('1', 'a\, u\, about\, above\, across\, after\, afterwards\, again\, against\, all\, almost\, alone\, along\, already\, also\, although\, always\, am\, among\, amongst\, amoungst\, amount\, an\, and\, another\, any\, anyhow\, anyone\, anything\, anyway\, anywhere\, are\, around\, as\, at\, back\, be\, became\, because\, become\, becomes\, becoming\, been\, before\, beforehand\, behind\, being\, below\, beside\, besides\, between\, beyond\, bill\, both\, bottom\, bull\, but\, by\, call\, can\, cannot\, cant\, co\, computer\, con\, could\, couldnt\, cry\, de\, describe\, detail\, do\, done\, down\, due\, during\, each\, eg\, eight\, either\, eleven\, else\, elsewhere\, empty\, enough\, etc\, even\, ever\, every\, everyone\, everything\, everywhere\, except\, few\, feet\, fifteen\, fify\, fill\, finish\, find\, first\, five\, for\, former\, formerly\, forty\, found\, four\, from\, front\, ft\, full\, further\, get\, give\, go\, had\, has\, hasnt\, have\, he\, hence\, her\, here\, hereafter\, hereby\, herein\, hereupon\, hers\, herself\, him\, himself\, his\, how\, however\, hundred\, i\, ie\, if\, in\, inc\, inch\, inches\, include\, includes\, indeed\, interest\, into\, is\, it\, its\, itself\, keep\, last\, latter\, latterly\, least\, less\, like\, ltd\, made\, many\, may\, me\, meanwhile\, might\, mill\, mine\, minus\, more\, moreover\, most\, mostly\, move\, much\, must\, my\, myself\, name\, namely\, neither\, never\, nevertheless\, next\, nine\, no\, nobody\, none\, noone\, nor\, not\, nothing\, now\, nowhere\, of\, off\, often\, on\, once\, one\, only\, onto\, or\, other\, others\, otherwise\, our\, ours\, ourselves\, out\, over\, own\, part\, pd\, pds\, per\, perhaps\, place\, please\, plus\, pound\, pounds\, put\, provide\, provides\, question\, questions\, rather\, re\, ready\, rugged\, same\, see\, seem\, seemed\, seeming\, seems\, serious\, several\, she\, should\, show\, side\, since\, sincere\, six\, sixty\, so\, some\, somehow\, someone\, something\, sometime\, sometimes\, somewhere\, start\, still\, such\, system\, take\, ten\, than\, that\, the\, their\, them\, themselves\, then\, thence\, there\, thereafter\, thereby\, therefore\, therein\, thereupon\, these\, they\, thick\, thin\, third\, this\, those\, though\, three\, through\, throughout\, thru\, thus\, to\, today\, together\, too\, top\, total\, toward\, towards\, twelve\, twenty\, two\, un\, under\, unes\, until\, up\, upon\, us\, use\, uses\, used\, very\, via\, want\, wanted\, was\, we\, weight\, well\, were\, wgt\, what\, whatever\, when\, whence\, whenever\, where\, whereafter\, whereas\, whereby\, wherein\, whereupon\, wherever\, whether\, which\, while\, whither\, who\, whoever\, whole\, whom\, whose\, why\, will\, with\, within\, without\, would\, wt\, yet\, you\, your\, yours\, yourself\, yourselves', '4', '30', 'Y', '', '', 'product\, products\, buy\, top\, best\, value\, store\, shop\, new\, used', 'buy product\, purchase products', 'Y', 'Y', 'Y', 'Y', 'N', 'N', '', 'N', '', '', '', '', '', '', '', '', '', 'N');